# rSTTask

Extends \Task

reStructuredText rendering task for Phing, the PHP build tool.

PHP version 5

category | Tasks
package | phing.tasks.ext
author | Christian Weiske cweiske@cweiske.de
license | LGPL v3 or later http://www.gnu.org/licenses/lgpl.html
link | http://www.phing.info/

### Methods

## Sets up this object internal stuff. i.e. the default mode.

    __construct()

## Add a set of files to be rendered.

    addFileset(\FileSet $fileset) : void

### Arguments

#### $fileset

`\FileSet`

Set of rst files to render

## Creates a filterchain, stores and returns it

    createFilterChain() : \FilterChain

### Response

`\FilterChain`

The created filterchain object

## Nested creator, creates one Mapper for this task

    createMapper() : \Mapper

throws |

### Response

`\Mapper`

The created Mapper type object

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Determines and returns the target file name from the input file and the configured destination name.

    getTargetFile(string $file, string $destination = null) : string

uses |

### Arguments

#### $file

`string`

Input file

#### $destination

`string`

Destination file or directory name, may be null

### Response

`string`

Target file name

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Finds the rst2* binary path

    getToolPath(string $format) : string

throws | When the tool cannot be found

### Arguments

#### $format

`string`

Output format

### Response

`string`

Full path to rst2$format

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Renders a single file and applies filters on it

    render(string $tool, string $source, string $targetFile) : void

### Arguments

#### $tool

`string`

conversion tool to use

#### $source

`string`

rST source file

#### $targetFile

`string`

target file name

## Renders a single file with the rST tool.

    renderFile(string $tool, string $source, string $targetFile) : void

throws | When the conversion fails

### Arguments

#### $tool

`string`

conversion tool to use

#### $source

`string`

rST source file

#### $targetFile

`string`

target file name

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## The setter for the attribute "destination"

    setDestination(string $destination) : void

### Arguments

#### $destination

`string`

Output file or directory. When it ends with a slash, it is taken as directory.

## The setter for the attribute "file"

    setFile(string $file) : void

### Arguments

#### $file

`string`

Path of file to render

## The setter for the attribute "format"

    setFormat(string $format) : void

throws | When the format is not supported

### Arguments

#### $format

`string`

Output format

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## The setter for the attribute "toolparam"

    setToolparam(string $param) : void

### Arguments

#### $param

`string`

Additional rst2* tool parameters

## The setter for the attribute "uptodate"

    setUptodate(string $uptodate) : void

### Arguments

#### $uptodate

`string`

True/false

### Properties

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Result format, defaults to "html".

    format : string

see | for all possible options
var |

### Type(s)

`string`

## Array of supported output formats

    supportedFormats : array

static

var |
see |

### Type(s)

`array`

## Maps formats to file extensions

    targetExt : array

static

var |

### Type(s)

`array`

## Input file in rST format.

    file : string

Required

var |

### Type(s)

`string`

## Additional rst2* tool parameters.

    toolParam : string

var |

### Type(s)

`string`

## Full path to the tool, i.e. /usr/local/bin/rst2html

    toolPath : string

var |

### Type(s)

`string`

## Output file or directory. May be omitted.

    destination : string

When it ends with a slash, it is considered to be a directory

var |

### Type(s)

`string`

## filesets

    filesets :

### Type(s)

``

## mapperElement

    mapperElement :

### Type(s)

``

## all filterchains objects assigned to this task

    filterChains : array

var |

### Type(s)

`array`

## mode to create directories with

    mode : integer

var |

### Type(s)

`integer`

## Only render files whole source files are newer than the target files

    uptodate : boolean

var |

### Type(s)

`boolean`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`